import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface TextObject {
    value: string;
}
interface Text {
    text: string;
    value: string;
    postgres: string;
    toString(): string;
    toJSON(): TextObject;
    equals(string: string): boolean;
    equals(object: Text | TextObject): boolean;
    safeEquals(string: string): SafeEquals<Text>;
    safeEquals(object: Text | TextObject): SafeEquals<Text>;
}
interface TextConstructor {
    from(string: string): Text;
    from(object: Text | TextObject): Text;
    safeFrom(string: string): SafeFrom<Text>;
    safeFrom(object: Text | TextObject): SafeFrom<Text>;
    /**
     * Returns `true` if `object` is a `Text`, `false` otherwise.
     */
    isText(object: any): object is Text;
}
declare const Text: TextConstructor;
export { Text, TextConstructor, TextObject };
