import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface CircleObject {
    x: number;
    y: number;
    radius: number;
}
interface Circle {
    x: number;
    y: number;
    radius: number;
    value: string;
    postgres: string;
    toString(): string;
    toJSON(): CircleObject;
    equals(string: string): boolean;
    equals(object: Circle | CircleObject): boolean;
    equals(x: number, y: number, radius: number): boolean;
    safeEquals(string: string): SafeEquals<Circle>;
    safeEquals(object: Circle | CircleObject): SafeEquals<Circle>;
    safeEquals(x: number, y: number, radius: number): SafeEquals<Circle>;
}
interface CircleConstructor {
    from(string: string): Circle;
    from(object: Circle | CircleObject): Circle;
    from(x: number, y: number, radius: number): Circle;
    safeFrom(string: string): SafeFrom<Circle>;
    safeFrom(object: Circle | CircleObject): SafeFrom<Circle>;
    safeFrom(x: number, y: number, radius: number): SafeFrom<Circle>;
    /**
     * Returns `true` if `object` is a `Circle`, `false` otherwise.
     */
    isCircle(object: any): object is Circle;
}
declare const Circle: CircleConstructor;
export { Circle, CircleConstructor, CircleObject };
