import { type ParseReturnType } from "@postgresql-typed/util";
import type { ParseContext } from "../types/ParseContext.js";
import type { SafeEquals } from "../types/SafeEquals.js";
import { IssueWithoutMessage } from "./PGTPError.js";
export declare abstract class PGTPBase<DataType> {
    constructor();
    abstract value: string | number | boolean;
    abstract postgres: string;
    abstract _equals(context: ParseContext): ParseReturnType<{
        readonly equals: boolean;
        readonly data: DataType;
    }>;
    equals(...data: unknown[]): boolean;
    safeEquals(...data: unknown[]): SafeEquals<DataType>;
    private _handleResult;
    setIssueForContext(context: ParseContext, issueData: IssueWithoutMessage): void;
}
