import { type ParseReturnType } from "@postgresql-typed/util";
import type { ParseContext } from "../types/ParseContext.js";
import type { SafeFrom } from "../types/SafeFrom.js";
import { IssueWithoutMessage } from "./PGTPError.js";
export declare abstract class PGTPConstructorBase<DataType> {
    constructor();
    abstract _parse(context: ParseContext): ParseReturnType<DataType>;
    from(...data: unknown[]): DataType;
    safeFrom(...data: unknown[]): SafeFrom<DataType>;
    private _handleResult;
    setIssueForContext(context: ParseContext, issueData: IssueWithoutMessage): void;
}
