/* eslint-disable unicorn/filename-case */
import { arrayToEnum } from "@postgresql-typed/util";
export const IssueCode = arrayToEnum([
    "invalid_n_length",
    "invalid_date",
    "invalid_key_type",
    "invalid_luxon_date",
    "invalid_range_bound",
    "invalid_string",
    "invalid_timezone",
    "invalid_type",
    "missing_keys",
    "not_finite",
    "not_whole",
    "too_big",
    "too_small",
    "unrecognized_keys",
]);
export class PGTPError extends Error {
    get error() {
        return this.issue;
    }
    constructor(issue) {
        super();
        this.issue = issue;
    }
    toString() {
        return this.message;
    }
    get message() {
        return this.issue.message;
    }
    get code() {
        return this.issue.code;
    }
}
//# sourceMappingURL=PGTPError.js.map